diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lte/model/lte-enb-phy.h ns-3.44/src/lte/model/lte-enb-phy.h
--- ns-3.43/src/lte/model/lte-enb-phy.h	2024-10-09 16:41:10.036656400 -0700
+++ ns-3.44/src/lte/model/lte-enb-phy.h	2025-03-09 16:55:49.599372000 -0700
@@ -27,7 +27,7 @@
 class LteUePhy;
 
 /**
- * \ingroup lte
+ * @ingroup lte
  * LteEnbPhy models the physical layer for the eNodeB
  */
 class LteEnbPhy : public LtePhy
@@ -45,16 +45,16 @@
 
     /**
      *
-     * \param dlPhy the downlink LteSpectrumPhy instance
-     * \param ulPhy the uplink LteSpectrumPhy instance
+     * @param dlPhy the downlink LteSpectrumPhy instance
+     * @param ulPhy the uplink LteSpectrumPhy instance
      */
     LteEnbPhy(Ptr<LteSpectrumPhy> dlPhy, Ptr<LteSpectrumPhy> ulPhy);
 
     ~LteEnbPhy() override;
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     // inherited from Object
@@ -62,79 +62,79 @@
     void DoDispose() override;
 
     /**
-     * \brief Get the PHY SAP provider
-     * \return a pointer to the SAP Provider of the PHY
+     * @brief Get the PHY SAP provider
+     * @return a pointer to the SAP Provider of the PHY
      */
     LteEnbPhySapProvider* GetLteEnbPhySapProvider();
 
     /**
-     * \brief Set the PHY SAP User
-     * \param s a pointer to the PHY SAP user
+     * @brief Set the PHY SAP User
+     * @param s a pointer to the PHY SAP user
      */
     void SetLteEnbPhySapUser(LteEnbPhySapUser* s);
 
     /**
-     * \brief Get the CPHY SAP provider
-     * \return a pointer to the SAP Provider
+     * @brief Get the CPHY SAP provider
+     * @return a pointer to the SAP Provider
      */
     LteEnbCphySapProvider* GetLteEnbCphySapProvider();
 
     /**
-     * \brief Set the CPHY SAP User
-     * \param s a pointer to the SAP user
+     * @brief Set the CPHY SAP User
+     * @param s a pointer to the SAP user
      */
     void SetLteEnbCphySapUser(LteEnbCphySapUser* s);
 
     /**
-     * \param pow the transmission power in dBm
+     * @param pow the transmission power in dBm
      */
     void SetTxPower(double pow);
 
     /**
-     * \return the transmission power in dBm
+     * @return the transmission power in dBm
      */
     double GetTxPower() const;
 
     /**
-     * \return the transmission power in dBm
+     * @return the transmission power in dBm
      */
     int8_t DoGetReferenceSignalPower() const;
 
     /**
-     * \param pow the noise figure in dB
+     * @param pow the noise figure in dB
      */
     void SetNoiseFigure(double pow);
 
     /**
-     * \return the noise figure in dB
+     * @return the noise figure in dB
      */
     double GetNoiseFigure() const;
 
     /**
-     * \param delay the TTI delay between MAC and channel
+     * @param delay the TTI delay between MAC and channel
      */
     void SetMacChDelay(uint8_t delay);
 
     /**
-     * \returns the TTI delay between MAC and channel
+     * @returns the TTI delay between MAC and channel
      */
     uint8_t GetMacChDelay() const;
 
     /**
-     * \return a pointer to the LteSpectrumPhy instance relative to the downlink
+     * @return a pointer to the LteSpectrumPhy instance relative to the downlink
      */
     Ptr<LteSpectrumPhy> GetDlSpectrumPhy() const;
 
     /**
-     * \return a pointer to the LteSpectrumPhy instance relative to the uplink
+     * @return a pointer to the LteSpectrumPhy instance relative to the uplink
      */
     Ptr<LteSpectrumPhy> GetUlSpectrumPhy() const;
 
     /**
-     * \brief set the resource blocks (a.k.a. sub channels) to be used in the downlink for
+     * @brief set the resource blocks (a.k.a. sub channels) to be used in the downlink for
      * transmission
      *
-     * \param mask a vector of integers, if the i-th value is j it means
+     * @param mask a vector of integers, if the i-th value is j it means
      * that the j-th resource block is used for transmission in the
      * downlink. If there is no i such that the value of the i-th
      * element is j, it means that RB j is not used.
@@ -142,10 +142,10 @@
     void SetDownlinkSubChannels(std::vector<int> mask);
 
     /**
-     * \brief set the resource blocks (a.k.a. sub channels) and its power
+     * @brief set the resource blocks (a.k.a. sub channels) and its power
      * to be used in the downlink for transmission
      *
-     * \param mask a vector of integers, if the i-th value is j it means
+     * @param mask a vector of integers, if the i-th value is j it means
      * that the j-th resource block is used for transmission in the
      * downlink. If there is no i such that the value of the i-th
      * element is j, it means that RB j is not used.
@@ -153,7 +153,7 @@
     void SetDownlinkSubChannelsWithPowerAllocation(std::vector<int> mask);
     /**
      *
-     * \return  a vector of integers, if the i-th value is j it means
+     * @return  a vector of integers, if the i-th value is j it means
      * that the j-th resource block is used for transmission in the
      * downlink. If there is no i such that the value of the i-th
      * element is j, it means that RB j is not used.
@@ -161,105 +161,105 @@
     std::vector<int> GetDownlinkSubChannels();
 
     /**
-     * \brief Generate power allocation map (i.e. tx power level for each RB)
+     * @brief Generate power allocation map (i.e. tx power level for each RB)
      *
-     * \param rnti indicates which UE will occupy this RB
-     * \param rbId indicates which RB UE is using,
+     * @param rnti indicates which UE will occupy this RB
+     * @param rbId indicates which RB UE is using,
      * power level for this RB is power level of UE
      */
     void GeneratePowerAllocationMap(uint16_t rnti, int rbId);
 
     /**
-     * \brief Create the PSD for TX
-     * \returns the PSD
+     * @brief Create the PSD for TX
+     * @returns the PSD
      */
     Ptr<SpectrumValue> CreateTxPowerSpectralDensity() override;
 
     /**
-     * \brief Create the PSD for TX with power allocation for each RB
-     * \return the PSD
+     * @brief Create the PSD for TX with power allocation for each RB
+     * @return the PSD
      */
     virtual Ptr<SpectrumValue> CreateTxPowerSpectralDensityWithPowerAllocation();
 
     /**
-     * \brief Calculate the channel quality for a given UE
-     * \param sinr a list of computed SINR
-     * \param ue the UE
+     * @brief Calculate the channel quality for a given UE
+     * @param sinr a list of computed SINR
+     * @param ue the UE
      */
     void CalcChannelQualityForUe(std::vector<double> sinr, Ptr<LteSpectrumPhy> ue);
 
     /**
-     * \brief Receive the control message
-     * \param msg the received message
+     * @brief Receive the control message
+     * @param msg the received message
      */
     virtual void ReceiveLteControlMessage(Ptr<LteControlMessage> msg);
 
     /**
-     * \brief Create the UL CQI feedback from SINR values perceived at
+     * @brief Create the UL CQI feedback from SINR values perceived at
      * the physical layer with the PUSCH signal received from eNB
-     * \param sinr SINR values vector
-     * \return UL CQI feedback in the format usable by an FF MAC scheduler
+     * @param sinr SINR values vector
+     * @return UL CQI feedback in the format usable by an FF MAC scheduler
      */
     FfMacSchedSapProvider::SchedUlCqiInfoReqParameters CreatePuschCqiReport(
         const SpectrumValue& sinr);
 
     /**
-     * \brief Create the UL CQI feedback from SINR values perceived at
+     * @brief Create the UL CQI feedback from SINR values perceived at
      * the physical layer with the SRS signal received from eNB
-     * \param sinr SINR values vector
-     * \return UL CQI feedback in the format usable by an FF MAC scheduler
+     * @param sinr SINR values vector
+     * @return UL CQI feedback in the format usable by an FF MAC scheduler
      */
     FfMacSchedSapProvider::SchedUlCqiInfoReqParameters CreateSrsCqiReport(
         const SpectrumValue& sinr);
 
     /**
-     * \brief Send the PDCCH and PCFICH in the first 3 symbols
-     * \param ctrlMsgList the list of control messages of PDCCH
+     * @brief Send the PDCCH and PCFICH in the first 3 symbols
+     * @param ctrlMsgList the list of control messages of PDCCH
      */
     void SendControlChannels(std::list<Ptr<LteControlMessage>> ctrlMsgList);
 
     /**
-     * \brief Send the PDSCH
-     * \param pb the PacketBurst to be sent
+     * @brief Send the PDSCH
+     * @param pb the PacketBurst to be sent
      */
     void SendDataChannels(Ptr<PacketBurst> pb);
 
     /**
-     * \param m the UL-CQI to be queued
+     * @param m the UL-CQI to be queued
      */
     void QueueUlDci(UlDciLteControlMessage m);
 
     /**
-     * \returns the list of UL-CQI to be processed
+     * @returns the list of UL-CQI to be processed
      */
     std::list<UlDciLteControlMessage> DequeueUlDci();
 
     /**
-     * \brief Start a LTE frame
+     * @brief Start a LTE frame
      */
     void StartFrame();
     /**
-     * \brief Start a LTE sub frame
+     * @brief Start a LTE sub frame
      */
     void StartSubFrame();
     /**
-     * \brief End a LTE sub frame
+     * @brief End a LTE sub frame
      */
     void EndSubFrame();
     /**
-     * \brief End a LTE frame
+     * @brief End a LTE frame
      */
     void EndFrame();
 
     /**
-     * \brief PhySpectrum received a new PHY-PDU
-     * \param p the packet received
+     * @brief PhySpectrum received a new PHY-PDU
+     * @param p the packet received
      */
     void PhyPduReceived(Ptr<Packet> p);
 
     /**
-     * \brief PhySpectrum received a new list of LteControlMessage
-     * \param msgList List of control messages
+     * @brief PhySpectrum received a new list of LteControlMessage
+     * @param msgList List of control messages
      */
     virtual void ReceiveLteControlMessageList(std::list<Ptr<LteControlMessage>> msgList);
 
@@ -270,25 +270,25 @@
     void ReportRsReceivedPower(const SpectrumValue& power) override;
 
     /**
-     * \brief Report the uplink HARQ feedback generated by LteSpectrumPhy to MAC
+     * @brief Report the uplink HARQ feedback generated by LteSpectrumPhy to MAC
      *
-     * \param mes UlInfoListElement_s
+     * @param mes UlInfoListElement_s
      */
     virtual void ReportUlHarqFeedback(UlInfoListElement_s mes);
 
     /**
-     * \brief Set the HARQ Phy module
+     * @brief Set the HARQ Phy module
      *
-     * \param harq the HARQ Phy
+     * @param harq the HARQ Phy
      */
     void SetHarqPhyModule(Ptr<LteHarqPhy> harq);
 
     /**
      * TracedCallback signature for the linear average of SRS SINRs.
      *
-     * \param [in] cellId
-     * \param [in] rnti
-     * \param [in] sinrLinear
+     * @param [in] cellId
+     * @param [in] rnti
+     * @param [in] sinrLinear
      */
     typedef void (*ReportUeSinrTracedCallback)(uint16_t cellId,
                                                uint16_t rnti,
@@ -298,9 +298,9 @@
     /**
      * TracedCallback signature for the linear average of SRS SINRs.
      *
-     * \param [in] cellId
-     * \param [in] spectrumValue
-     * \deprecated The non-const \c Ptr<SpectrumValue> argument is deprecated
+     * @param [in] cellId
+     * @param [in] spectrumValue
+     * @deprecated The non-const \c Ptr<SpectrumValue> argument is deprecated
      * and will be changed to \c Ptr<const SpectrumValue> in a future release.
      */
     // NS_DEPRECATED() - tag for future removal
@@ -312,60 +312,60 @@
     /**
      * Set bandwidth function
      *
-     * \param ulBandwidth UL bandwidth
-     * \param dlBandwidth DL bandwidth
+     * @param ulBandwidth UL bandwidth
+     * @param dlBandwidth DL bandwidth
      */
     void DoSetBandwidth(uint16_t ulBandwidth, uint16_t dlBandwidth);
     /**
      * Set EARFCN
      *
-     * \param dlEarfcn DL EARFCN
-     * \param ulEarfcn UL EARFCN
+     * @param dlEarfcn DL EARFCN
+     * @param ulEarfcn UL EARFCN
      */
     void DoSetEarfcn(uint32_t dlEarfcn, uint32_t ulEarfcn);
     /**
      * Add UE
      *
-     * \param rnti RNTI
+     * @param rnti RNTI
      */
     void DoAddUe(uint16_t rnti);
     /**
      * Remove UE
      *
-     * \param rnti RNTI
+     * @param rnti RNTI
      */
     void DoRemoveUe(uint16_t rnti);
     /**
      * Set PA
      *
-     * \param rnti RNTI
-     * \param pa PA
+     * @param rnti RNTI
+     * @param pa PA
      */
     void DoSetPa(uint16_t rnti, double pa);
     /**
      * Set transmission mode
      *
-     * \param rnti RNTI
-     * \param txMode transmit mode
+     * @param rnti RNTI
+     * @param txMode transmit mode
      */
     void DoSetTransmissionMode(uint16_t rnti, uint8_t txMode);
     /**
      * Set source configuration index
      *
-     * \param rnti RNTI
-     * \param srcCi source configuration index
+     * @param rnti RNTI
+     * @param srcCi source configuration index
      */
     void DoSetSrsConfigurationIndex(uint16_t rnti, uint16_t srcCi);
     /**
      * Set master information block
      *
-     * \param mib LteRrcSap::MasterInformationBlock
+     * @param mib LteRrcSap::MasterInformationBlock
      */
     void DoSetMasterInformationBlock(LteRrcSap::MasterInformationBlock mib);
     /**
      * Set system information block
      *
-     * \param sib1 LteRrcSap::SystemInformationBlockType1
+     * @param sib1 LteRrcSap::SystemInformationBlockType1
      */
     void DoSetSystemInformationBlockType1(LteRrcSap::SystemInformationBlockType1 sib1);
 
@@ -374,34 +374,34 @@
     /**
      * Send LTE Control Message function
      *
-     * \param msg LTE control message
+     * @param msg LTE control message
      */
     void DoSendLteControlMessage(Ptr<LteControlMessage> msg);
     /**
      * Get MAC ch TTI delay function
      *
-     * \returns delay value
+     * @returns delay value
      */
     uint8_t DoGetMacChTtiDelay();
 
     /**
      * Add the given RNTI to the list of attached UE #m_ueAttached.
-     * \param rnti RNTI of a UE
-     * \return true if the RNTI has _not_ existed before, or false otherwise.
+     * @param rnti RNTI of a UE
+     * @return true if the RNTI has _not_ existed before, or false otherwise.
      */
     bool AddUePhy(uint16_t rnti);
     /**
      * Remove the given RNTI from the list of attached UE #m_ueAttached.
-     * \param rnti RNTI of a UE
-     * \return true if the RNTI has existed before, or false otherwise.
+     * @param rnti RNTI of a UE
+     * @return true if the RNTI has existed before, or false otherwise.
      */
     bool DeleteUePhy(uint16_t rnti);
 
     /**
      * Create SRS report function
      *
-     * \param rnti the RNTI
-     * \param srs the SRS
+     * @param rnti the RNTI
+     * @param srs the SRS
      */
     void CreateSrsReport(uint16_t rnti, double srs);
 
@@ -484,7 +484,7 @@
      * The `ReportInterference` trace source. Reporting the interference per PHY
      * RB (TS 36.214 section 5.2.2, measured on DATA). Exporting cell ID and
      * interference linear power per RB basis.
-     * \deprecated The non-const \c Ptr<SpectrumValue> argument is deprecated
+     * @deprecated The non-const \c Ptr<SpectrumValue> argument is deprecated
      * and will be changed to \c Ptr<const SpectrumValue> in a future release.
      */
     // NS_DEPRECATED() - tag for future removal
@@ -492,7 +492,7 @@
     /**
      * The `InterferenceSamplePeriod` attribute. The sampling period for
      * reporting interference stats.
-     * \todo In what unit is this?
+     * @todo In what unit is this?
      */
     uint16_t m_interferenceSamplePeriod;
     uint16_t m_interferenceSampleCounter; ///< interference sample counter
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lte/model/lte-enb-phy-sap.h ns-3.44/src/lte/model/lte-enb-phy-sap.h
--- ns-3.43/src/lte/model/lte-enb-phy-sap.h	2024-10-09 16:41:10.036656400 -0700
+++ ns-3.44/src/lte/model/lte-enb-phy-sap.h	2025-03-09 16:55:49.599372000 -0700
@@ -12,7 +12,7 @@
 #include "ff-mac-common.h"
 #include "ff-mac-sched-sap.h"
 
-#include <ns3/packet.h>
+#include "ns3/packet.h"
 
 namespace ns3
 {
@@ -31,20 +31,20 @@
     virtual ~LteEnbPhySapProvider();
 
     /**
-     * \brief Send the MAC PDU to the channel
-     * \param p the MAC PDU to send
+     * @brief Send the MAC PDU to the channel
+     * @param p the MAC PDU to send
      */
     virtual void SendMacPdu(Ptr<Packet> p) = 0;
 
     /**
-     * \brief Send SendLteControlMessage (PDCCH map, CQI feedbacks) using the ideal control channel
-     * \param msg the Ideal Control Message to send
+     * @brief Send SendLteControlMessage (PDCCH map, CQI feedbacks) using the ideal control channel
+     * @param msg the Ideal Control Message to send
      */
     virtual void SendLteControlMessage(Ptr<LteControlMessage> msg) = 0;
 
     /**
-     * \brief Get the delay from MAC to Channel expressed in TTIs
-     * \returns MAC channel TTI delay
+     * @brief Get the delay from MAC to Channel expressed in TTIs
+     * @returns MAC channel TTI delay
      */
     virtual uint8_t GetMacChTtiDelay() = 0;
 };
@@ -63,48 +63,48 @@
     /**
      * Called by the Phy to notify the MAC of the reception of a new PHY-PDU
      *
-     * \param p
+     * @param p
      */
     virtual void ReceivePhyPdu(Ptr<Packet> p) = 0;
 
     /**
-     * \brief Trigger the start from a new frame (input from Phy layer)
-     * \param frameNo frame number
-     * \param subframeNo subframe number
+     * @brief Trigger the start from a new frame (input from Phy layer)
+     * @param frameNo frame number
+     * @param subframeNo subframe number
      */
     virtual void SubframeIndication(uint32_t frameNo, uint32_t subframeNo) = 0;
 
     /**
-     * \brief Receive SendLteControlMessage (PDCCH map, CQI feedbacks) using the ideal control
+     * @brief Receive SendLteControlMessage (PDCCH map, CQI feedbacks) using the ideal control
      * channel
-     * \param msg the Ideal Control Message to receive
+     * @param msg the Ideal Control Message to receive
      */
     virtual void ReceiveLteControlMessage(Ptr<LteControlMessage> msg) = 0;
 
     /**
      * notify the reception of a RACH preamble on the PRACH
      *
-     * \param prachId the ID of the preamble
+     * @param prachId the ID of the preamble
      */
     virtual void ReceiveRachPreamble(uint32_t prachId) = 0;
 
     /**
-     * \brief Returns to MAC level the UL-CQI evaluated
-     * \param ulcqi the UL-CQI (see FF MAC API 4.3.29)
+     * @brief Returns to MAC level the UL-CQI evaluated
+     * @param ulcqi the UL-CQI (see FF MAC API 4.3.29)
      */
     virtual void UlCqiReport(FfMacSchedSapProvider::SchedUlCqiInfoReqParameters ulcqi) = 0;
 
     /**
      * Notify the HARQ on the UL transmission status
      *
-     * \param params
+     * @param params
      */
     virtual void UlInfoListElementHarqFeedback(UlInfoListElement_s params) = 0;
 
     /**
      * Notify the HARQ on the DL transmission status
      *
-     * \param params
+     * @param params
      */
     virtual void DlInfoListElementHarqFeedback(DlInfoListElement_s params) = 0;
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lte/model/lte-enb-rrc.cc ns-3.44/src/lte/model/lte-enb-rrc.cc
--- ns-3.43/src/lte/model/lte-enb-rrc.cc	2024-10-09 16:41:10.036656400 -0700
+++ ns-3.44/src/lte/model/lte-enb-rrc.cc	2025-03-09 16:55:49.599372000 -0700
@@ -25,14 +25,14 @@
 #include "lte-rlc-um.h"
 #include "lte-rlc.h"
 
-#include <ns3/abort.h>
-#include <ns3/fatal-error.h>
-#include <ns3/log.h>
-#include <ns3/object-factory.h>
-#include <ns3/object-map.h>
-#include <ns3/packet.h>
-#include <ns3/pointer.h>
-#include <ns3/simulator.h>
+#include "ns3/abort.h"
+#include "ns3/fatal-error.h"
+#include "ns3/log.h"
+#include "ns3/object-factory.h"
+#include "ns3/object-map.h"
+#include "ns3/packet.h"
+#include "ns3/pointer.h"
+#include "ns3/simulator.h"
 
 namespace ns3
 {
@@ -44,7 +44,7 @@
 ///////////////////////////////////////////
 
 /**
- * \brief Class for forwarding CMAC SAP User functions.
+ * @brief Class for forwarding CMAC SAP User functions.
  */
 class EnbRrcMemberLteEnbCmacSapUser : public LteEnbCmacSapUser
 {
@@ -52,8 +52,8 @@
     /**
      * Constructor
      *
-     * \param rrc ENB RRC
-     * \param componentCarrierId
+     * @param rrc ENB RRC
+     * @param componentCarrierId
      */
     EnbRrcMemberLteEnbCmacSapUser(LteEnbRrc* rrc, uint8_t componentCarrierId);
 
@@ -102,31 +102,6 @@
 // UeManager
 ///////////////////////////////////////////
 
-/// Map each of UE Manager states to its string representation.
-static const std::string g_ueManagerStateName[UeManager::NUM_STATES] = {
-    "INITIAL_RANDOM_ACCESS",
-    "CONNECTION_SETUP",
-    "CONNECTION_REJECTED",
-    "ATTACH_REQUEST",
-    "CONNECTED_NORMALLY",
-    "CONNECTION_RECONFIGURATION",
-    "CONNECTION_REESTABLISHMENT",
-    "HANDOVER_PREPARATION",
-    "HANDOVER_JOINING",
-    "HANDOVER_PATH_SWITCH",
-    "HANDOVER_LEAVING",
-};
-
-/**
- * \param s The UE manager state.
- * \return The string representation of the given state.
- */
-static const std::string&
-ToString(UeManager::State s)
-{
-    return g_ueManagerStateName[s];
-}
-
 NS_OBJECT_ENSURE_REGISTERED(UeManager);
 
 UeManager::UeManager()
@@ -296,7 +271,7 @@
         break;
 
     default:
-        NS_FATAL_ERROR("unexpected state " << ToString(m_state));
+        NS_FATAL_ERROR("unexpected state " << m_state);
         break;
     }
     m_caSupportConfigured = false;
@@ -381,7 +356,7 @@
     }
     else
     {
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
     }
 }
 
@@ -640,7 +615,7 @@
     break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -780,7 +755,7 @@
     break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -975,7 +950,7 @@
     break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -1027,7 +1002,7 @@
         break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -1051,7 +1026,7 @@
         break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -1078,7 +1053,7 @@
 UeManager::RecvUeContextRelease(EpcX2SapUser::UeContextReleaseParams params)
 {
     NS_LOG_FUNCTION(this);
-    NS_ASSERT_MSG(m_state == HANDOVER_LEAVING, "method unexpected in state " << ToString(m_state));
+    NS_ASSERT_MSG(m_state == HANDOVER_LEAVING, "method unexpected in state " << m_state);
     m_handoverLeavingTimeout.Cancel();
 }
 
@@ -1086,7 +1061,7 @@
 UeManager::RecvHandoverCancel(EpcX2SapUser::HandoverCancelParams params)
 {
     NS_LOG_FUNCTION(this);
-    NS_ASSERT_MSG(m_state == HANDOVER_JOINING, "method unexpected in state " << ToString(m_state));
+    NS_ASSERT_MSG(m_state == HANDOVER_JOINING, "method unexpected in state " << m_state);
     m_handoverJoiningTimeout.Cancel();
 }
 
@@ -1164,7 +1139,7 @@
     break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -1198,7 +1173,7 @@
         break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -1242,13 +1217,11 @@
     // This case is added to NS-3 in order to handle bearer de-activation scenario for CONNECTED
     // state UE
     case CONNECTED_NORMALLY:
-        NS_LOG_INFO("ignoring RecvRrcConnectionReconfigurationCompleted in state "
-                    << ToString(m_state));
+        NS_LOG_INFO("ignoring RecvRrcConnectionReconfigurationCompleted in state " << m_state);
         break;
 
     case HANDOVER_LEAVING:
-        NS_LOG_INFO("ignoring RecvRrcConnectionReconfigurationCompleted in state "
-                    << ToString(m_state));
+        NS_LOG_INFO("ignoring RecvRrcConnectionReconfigurationCompleted in state " << m_state);
         break;
 
     case HANDOVER_JOINING: {
@@ -1285,7 +1258,7 @@
     break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 }
@@ -1305,7 +1278,7 @@
         break;
 
     default:
-        NS_FATAL_ERROR("method unexpected in state " << ToString(m_state));
+        NS_FATAL_ERROR("method unexpected in state " << m_state);
         break;
     }
 
@@ -1685,11 +1658,11 @@
 void
 UeManager::SwitchToState(State newState)
 {
-    NS_LOG_FUNCTION(this << ToString(newState));
+    NS_LOG_FUNCTION(this << newState);
     State oldState = m_state;
     m_state = newState;
-    NS_LOG_INFO(this << " IMSI " << m_imsi << " RNTI " << m_rnti << " UeManager "
-                     << ToString(oldState) << " --> " << ToString(newState));
+    NS_LOG_INFO(this << " IMSI " << m_imsi << " RNTI " << m_rnti << " UeManager " << oldState
+                     << " --> " << newState);
     m_stateTransitionTrace(m_imsi,
                            m_rrc->ComponentCarrierToCellId(m_componentCarrierId),
                            m_rnti,
@@ -2344,7 +2317,7 @@
             m_ueMeasConfig.reportConfigToAddModList.size() * m_numberOfComponentCarriers,
         "Measurement identities and reporting configuration should not have different quantity");
 
-    if (Simulator::Now() != Seconds(0))
+    if (!Simulator::Now().IsZero())
     {
         NS_FATAL_ERROR("AddUeMeasReportConfig may not be called after the simulation has run");
     }
@@ -2608,7 +2581,7 @@
     NS_LOG_FUNCTION(this << rnti);
     NS_ASSERT_MSG(GetUeManager(rnti)->GetState() == UeManager::INITIAL_RANDOM_ACCESS,
                   "ConnectionRequestTimeout in unexpected state "
-                      << ToString(GetUeManager(rnti)->GetState()));
+                      << GetUeManager(rnti)->GetState());
     m_rrcTimeoutTrace(GetUeManager(rnti)->GetImsi(),
                       rnti,
                       ComponentCarrierToCellId(GetUeManager(rnti)->GetComponentCarrierId()),
@@ -2621,8 +2594,7 @@
 {
     NS_LOG_FUNCTION(this << rnti);
     NS_ASSERT_MSG(GetUeManager(rnti)->GetState() == UeManager::CONNECTION_SETUP,
-                  "ConnectionSetupTimeout in unexpected state "
-                      << ToString(GetUeManager(rnti)->GetState()));
+                  "ConnectionSetupTimeout in unexpected state " << GetUeManager(rnti)->GetState());
     m_rrcTimeoutTrace(GetUeManager(rnti)->GetImsi(),
                       rnti,
                       ComponentCarrierToCellId(GetUeManager(rnti)->GetComponentCarrierId()),
@@ -2636,7 +2608,7 @@
     NS_LOG_FUNCTION(this << rnti);
     NS_ASSERT_MSG(GetUeManager(rnti)->GetState() == UeManager::CONNECTION_REJECTED,
                   "ConnectionRejectedTimeout in unexpected state "
-                      << ToString(GetUeManager(rnti)->GetState()));
+                      << GetUeManager(rnti)->GetState());
     m_rrcTimeoutTrace(GetUeManager(rnti)->GetImsi(),
                       rnti,
                       ComponentCarrierToCellId(GetUeManager(rnti)->GetComponentCarrierId()),
@@ -2649,8 +2621,7 @@
 {
     NS_LOG_FUNCTION(this << rnti);
     NS_ASSERT_MSG(GetUeManager(rnti)->GetState() == UeManager::HANDOVER_JOINING,
-                  "HandoverJoiningTimeout in unexpected state "
-                      << ToString(GetUeManager(rnti)->GetState()));
+                  "HandoverJoiningTimeout in unexpected state " << GetUeManager(rnti)->GetState());
     m_handoverFailureJoiningTrace(
         GetUeManager(rnti)->GetImsi(),
         rnti,
@@ -2677,8 +2648,7 @@
 {
     NS_LOG_FUNCTION(this << rnti);
     NS_ASSERT_MSG(GetUeManager(rnti)->GetState() == UeManager::HANDOVER_LEAVING,
-                  "HandoverLeavingTimeout in unexpected state "
-                      << ToString(GetUeManager(rnti)->GetState()));
+                  "HandoverLeavingTimeout in unexpected state " << GetUeManager(rnti)->GetState());
     m_handoverFailureLeavingTrace(
         GetUeManager(rnti)->GetImsi(),
         rnti,
@@ -3166,8 +3136,7 @@
     {
         isHandoverAllowed = false;
         NS_LOG_LOGIC(this << " handover is not allowed because the UE"
-                          << " rnti=" << rnti << " is in " << ToString(ueManager->GetState())
-                          << " state");
+                          << " rnti=" << rnti << " is in " << ueManager->GetState() << " state");
     }
 
     if (isHandoverAllowed)
@@ -3525,4 +3494,37 @@
     }
 }
 
+std::ostream&
+operator<<(std::ostream& os, UeManager::State state)
+{
+    switch (state)
+    {
+    case UeManager::State::INITIAL_RANDOM_ACCESS:
+        return os << "INITIAL_RANDOM_ACCESS";
+    case UeManager::State::CONNECTION_SETUP:
+        return os << "CONNECTION_SETUP";
+    case UeManager::State::CONNECTION_REJECTED:
+        return os << "CONNECTION_REJECTED";
+    case UeManager::State::ATTACH_REQUEST:
+        return os << "ATTACH_REQUEST";
+    case UeManager::State::CONNECTED_NORMALLY:
+        return os << "CONNECTED_NORMALLY";
+    case UeManager::State::CONNECTION_RECONFIGURATION:
+        return os << "CONNECTION_RECONFIGURATION";
+    case UeManager::State::CONNECTION_REESTABLISHMENT:
+        return os << "CONNECTION_REESTABLISHMENT";
+    case UeManager::State::HANDOVER_PREPARATION:
+        return os << "HANDOVER_PREPARATION";
+    case UeManager::State::HANDOVER_JOINING:
+        return os << "HANDOVER_JOINING";
+    case UeManager::State::HANDOVER_PATH_SWITCH:
+        return os << "HANDOVER_PATH_SWITCH";
+    case UeManager::State::HANDOVER_LEAVING:
+        return os << "HANDOVER_LEAVING";
+    case UeManager::State::NUM_STATES:
+        return os << "NUM_STATES";
+    };
+    return os << "UNKNOWN(" << static_cast<uint32_t>(state) << ")";
+}
+
 } // namespace ns3
